function isNotBlank(a) {
	if(a == undefined || a == null || a == "null" || a == "undefined" || a.length == 0) {
		return false
	}
	return true
}

function getEle(eId) {
	try {
		return document.getElementById(eId);
	} catch(e) {
		console.log(e);
	}
	return null;
}

function getEleVal(eId) {
	try {
		return document.getElementById(eId).value;
	} catch(e) {
		console.log(e);
	}
	return null;
}

function getEleBooleanVal(eId) {
	try {
		return parseBoolean(document.getElementById(eId).value);
	} catch(e) {
		console.log(e);
	}
	return null;
}

function getEleText(eId) {
	try {
		return document.getElementById(eId).innerText;
	} catch(e) {
		console.log(e);
	}
	return null;
}

function setEleText(eId, v) {
	try {
		document.getElementById(eId).innerText = v;
	} catch(e) {
		console.log(e);
	}
}

function setEleHtml(eId, v) {
	try {
		document.getElementById(eId).innerHTML = v;
	} catch(e) {
		console.log(e);
	}
}

function setEleVal(eId, v) {
	try {
		document.getElementById(eId).value = v;
	} catch(e) {
		console.log(e);
	}
}

function showEle(eId, inline) {
	try {
		if(containsClass(eId, 'mui-hidden')) {
			removeClass(eId, 'mui-hidden');
		}
		if(isNotBlank(inline) && inline) {
			addClass(eId, 'mui-line');
		} else {
			addClass(eId, 'mui-block');
		}
	} catch(e) {
		console.log(e);
	}
}

function parseBoolean(string) {
	switch(String(string).toLowerCase()) {
		case "true":
		case "1":
		case "yes":
		case "y":
			return true;
		case "false":
		case "0":
		case "no":
		case "n":
			return false;
		default:
			return undefined;
	}
}

function hideEle(eId) {
	try {
		if(containsClass(eId, 'mui-block')) {
			removeClass(eId, 'mui-block');
		}
		addClass(eId, 'mui-hidden');
	} catch(e) {
		console.log(e);
	}
}

function addClass(eId, cName) {
	try {
		getEle(eId).classList.add(cName);
	} catch(e) {
		console.log(e);
	}
}

function removeClass(eId, cName) {
	try {
		getEle(eId).classList.remove(cName);
	} catch(e) {
		console.log(e);
	}
}

function containsClass(eId, cName) {
	try {
		return getEle(eId).classList.contains(cName);
	} catch(e) {
		console.log(e);
	}
	return false;
}
//设置cookie
function setCookie(cname, cvalue, exdays) {
	var d = new Date();
	d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
	var expires = "expires=" + d.toUTCString();
	document.cookie = cname + "=" + encodeURIComponent(cvalue) + "; " + expires + ";path=/";
}
//获取cookie
function getCookie(cname) {
	try {
		var name = cname + "=";
		var ca = document.cookie.split(';');
		for(var i = 0; i < ca.length; i++) {
			var c = ca[i];
			while(c.charAt(0) == ' ') c = c.substring(1);
			if(c.indexOf(name) != -1) return c.substring(name.length, c.length);
		}
	} catch(e) {
		console.log(e);
	}
	return "";
}
//清除cookie  
function clearCookie(name) {
	setCookie(name, "", -1);
}

function getSessionStorage(key) {
	return window.sessionStorage.getItem(key);
}

function setSessionStorage(key, value) {
	return window.sessionStorage.setItem(key, value);
}

function removeSessionStorage(key) {
	window.sessionStorage.removeItem(key);
}

function isDigital(b) {
	var a = /^\d$/;
	return a.test(b)
}

function isNumWord(value) {
	var Regx = /^[A-Za-z0-9]*$/;
	if(Regx.test(value)) {
		return true;
	} else {
		return false;
	}
}

function textLimit(d, c, b) {
	if(!d) {
		return false
	}
	var a = d.trim().length;
	if(a < c || a > b) {
		return false
	}
	return true
}

function testEmail(b) {
	var a = /^[a-zA-Z0-9]+@[a-zA-Z0-9]+.[a-z][a-z.]{2,8}$/;
	return a.test(b)
}

function testGeolocation() {
	if(!!navigator.geolocation) {
		testGeolocation = function() {
			return true
		};
		return testGeolocation()
	}
	testGeolocation = function() {
		return false
	};
	return testGeolocation()
}

function testPhone(b) {
	var a = /^1\d{10}$/;
	return a.test(b)
}

function testPass(b) {
	var a = /^[a-zA-Z0-9]{6,20}$/;
	return a.test(b)
}

function isContains(str1, str2) {
	if(!isNotBlank(str1) || !isNotBlank(str2)) {
		return false;
	}
	return(str1.indexOf(str2) >= 0);
}

function genBillNo() {
	var d = new Date();
	var vYear = d.getFullYear();
	var vMon = d.getMonth() + 1;
	var vDay = d.getDate();
	var h = d.getHours();
	var m = d.getMinutes();
	var se = d.getSeconds();
	var ms = d.getMilliseconds();
	billno = "" + vYear + (vMon < 10 ? "0" + vMon : vMon) + (vDay < 10 ? "0" + vDay : vDay) + (h < 10 ? "0" + h : h) + (m < 10 ? "0" + m : m) + (se < 10 ? "0" + se : se) + ms;
	return billno;
};

function randomString(len) {
	len = len || 32;
	var $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
	var maxPos = $chars.length;
	var pwd = '';
	for(i = 0; i < len; i++) {
		pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
	}
	return pwd;
}

function addDate(dd, dadd) {
	var a = new Date(dd)
	a = a.valueOf()
	a = a + dadd * 24 * 60 * 60 * 1000
	a = new Date(a)
	return a;
}

var a = new Array("日", "一", "二", "三", "四", "五", "六");

function getWeek(dd) {
	var week = dd.getDay();
	return a[week];
}

//格式化日期,
function formatDate(date, format) {
	var paddNum = function(num) {
			num += "";
			return num.replace(/^(\d)$/, "0$1");
		}
		//指定格式字符
	var cfg = {
		yyyy: date.getFullYear(), //年 : 4位
		yy: date.getFullYear().toString().substring(2), //年 : 2位

		M: date.getMonth() + 1, //月 : 如果1位的时候不补0

		MM: paddNum(date.getMonth() + 1), //月 : 如果1位的时候补0

		d: date.getDate(), //日 : 如果1位的时候不补0

		dd: paddNum(date.getDate()), //日 : 如果1位的时候补0

		hh: date.getHours(), //时

		mm: date.getMinutes(), //分

		ss: date.getSeconds() //秒
	}
	format || (format = "yyyy-MM-dd hh:mm:ss");
	return format.replace(/([a-z])(\1)*/ig, function(m) {
		return cfg[m];
	});
}
Number.prototype.formatMoney = function(places, symbol, thousand, decimal) {
	places = !isNaN(places = Math.abs(places)) ? places : 2;
	symbol = symbol !== undefined ? symbol : "$";
	thousand = thousand || ",";
	decimal = decimal || ".";
	var number = this,
		negative = number < 0 ? "-" : "",
		i = parseInt(number = Math.abs(+number || 0).toFixed(places), 10) + "",
		j = (j = i.length) > 3 ? j % 3 : 0;
	return symbol + negative + (j ? i.substr(0, j) + thousand : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousand) + (places ? decimal + Math.abs(number - i).toFixed(places).slice(2) : "");
};

function getRTime(endTime) {
	var EndTime = new Date(endTime);
	var NowTime = new Date();
	var t = EndTime.getTime() - NowTime.getTime();
	var d = 0;
	var h = 0;
	var m = 0;
	var s = 0;
	if(t >= 0) {
		d = Math.floor(t / 1000 / 60 / 60 / 24);
		h = Math.floor(t / 1000 / 60 / 60 % 24);
		m = Math.floor(t / 1000 / 60 % 60);
		s = Math.floor(t / 1000 % 60);
	}
	var o = {
		d: d,
		h: h,
		m: m,
		s: s
	}
	return o;
}