(function() {
	yb_product = {
		init: function() {
			this.initCurEle();
			this.eventInit();
			this.loadItemInfo();
			this.loadCart();
			var pull = mui('#comment-scroll').pullRefresh();
			pull.pullupLoading();
			this.loadRecom();
		},
		data: {
			pid: 0,
			sericesBorrowedCount: 0,
			sericesBookStatus: 0,
			borrowedBookID: '',
			saleAble: true,
			lendAble: true,
			saleStock: 1,
			lendStock: 1,
			goodsStatus: 1,
			bookStatus: 1,
			isFavorite: false,
			commentPage: 0,
			op1: 0,
			op2: 0
		},
		initCurEle: function() {
			this.data.pid = getEleVal('pid');
			if(getEleBooleanVal('h-isSerices')) {
				showEle('serices-div');
				mui("#serices-div button").each(function() {
					this.id = 'sericesbid' + this.value.toString();
				});
			}
		},
		loadItemInfo: function() {
			var reqStr = {
				id: this.data.pid
			};
			ybAjaxGet(YBApp.URL.BOOK_MYITEM, reqStr, this.loadMyBookItem);
		},
		loadMyBookItem: function(jsonObj) {
			if(!isNotBlank(jsonObj)) {
				return;
			}
			if(jsonObj.success) {
				var r = jsonObj.data;
				yb_product.data.saleAble = r.saleAble;
				yb_product.data.saleStock = r.saleStock;
				yb_product.data.lendAble = r.lendAble;
				yb_product.data.lendStock = r.lendStock;
				yb_product.data.goodsStatus = r.goodsStatus;
				yb_product.data.bookStatus = r.bookStatus;
				yb_product.data.isFavorite = r.favorite;

				if(r.borrowBookRentalDiscount < 1 && r.borrowBookRentalDiscount > 0) {
					hideEle('rental-area');
					showEle('vipRental-area');
					setEleText('item-vipRental', r.discountRentalShow);
					setEleText('item-vipRentalDiscount', r.borrowBookRentalDiscountShow);
				}
				if(parseInt(r.borrowTimes) > 0) {
					showEle('item-borrowed');
				}
				if(isNotBlank(r.promotional)) {
					setEleText('item-promotion－word', r.promotional);
					showEle('item-promotion－word');
				}
				if(r.favorite) {
					removeClass('favorite-btn-icon', 'nofavorite-icon');
					addClass('favorite-btn-icon', 'favorite-icon');
					setEleText('favorte-btn-text', '已收藏');
				}
				if(r.serices) {
					var sericesBookStatus = r.sericesStatus;
					mui.each(sericesBookStatus, function(idx, obj) {
						var ele = getEle('sericesbid' + obj.bookId.toString());
						if(isNotBlank(ele)) {
							ele.setAttribute('data-gstatus', obj.goodsStatus);
							ele.setAttribute('data-bstatus', obj.bookStatus);
							ele.setAttribute('data-lendable', obj.lendAble);
							ele.setAttribute('data-lendstock', obj.lendStock);
						}
					});
				}
				if(isNotBlank(r.lendBookOptions)) {
					var h = lendBookOptionInit(r.lendBookOptions);
					setEleHtml('lendBookOption', h);
				}
				setEleText('pj-count', r.comments);
				if(r.comments == 0) {
					showEle('no-content');
					mui('#comment-scroll').pullRefresh().disablePullupToRefresh();
					showEle('no-pj-notice');
				}
				if(isNotBlank(r.praiseDegree)) {
					setEleHtml('pj-praiseDegree', '<span class="fz_red">' + r.praiseDegree + '%</span>&nbsp;好评');
				}
				updateBuyAndBorrowButtonStatus();
			} else {
				var msg = jsonObj.msg;
			}
		},
		loadComment: function() {
			var reqStr = {
				id: yb_product.data.pid,
				page: yb_product.data.commentPage,
				num: 10
			};
			ybAjaxGet(YBApp.URL.BOOK_COMMENT, reqStr, function(jsonObj) {
				if(!isNotBlank(jsonObj)) {
					return;
				}
				hideEle('pj-loading');
				if(jsonObj.success) {
					var resultArray = jsonObj.data;
					var table = getEle('comment-scroll-table-view');
					var pjShort = getEle('pj-short');
					var c = 0;
					mui.each(resultArray, function(idx, obj) {
						var ul = document.createElement('ul');
						ul.className = 'mui-table-view comment-diver';
						ul.innerHTML = goodsComment(obj);
						table.appendChild(ul);
						if(yb_product.data.commentPage == 0 && c < 3) {
							var li = document.createElement('li');
							li.className = 'mui-table-view-cell mui-collapse-content';
							li.innerHTML = shortPJ(obj);
							pjShort.appendChild(li);
							c = c + 1;
						}
					});
					yb_product.data.commentPage += 1;
					mui('#comment-scroll').pullRefresh().endPullupToRefresh(resultArray.length < reqStr.num); //参数为true代表没有更多数据了。
				}
			});
		},
		loadRecom: function() {
			ybAjaxGet("/services/book/getRecommend", null, function(jsonObj) {
				hideEle('rec-loading');
				if(jsonObj.success) {
					var recHtml = htmlRecommend(jsonObj.data);
					var recommendSwiper = new Swiper(".related-item-list", {
						pagination: '.swiper-pagination',
						slidesOffsetBefore: 10,
						slidesPerView: 3,
						paginationType: 'bullets',
						paginationClickable: true,
						freeMode: false,
						slidesPerColumn: 2,
						lazyLoading: true
					});
					recommendSwiper.stopAutoplay();
					recommendSwiper.removeAllSlides();
					if(isNotBlank(recommendSwiper)) {
						recommendSwiper.appendSlide(recHtml);
						recommendSwiper.startAutoplay();
					}
				}
			}, false);
		},
		loadCart: function() {
			var reqStr = {
				vUid: YBApp.data.vUid,
			};
			ybAjaxGet(YBApp.URL.CART_DETAIL, reqStr, updaCartNum);
		},
		addBorrowCart: function(options) {
			if(YBApp.connecting) {
				mui.toast(YBApp.Str.NETWORK_BUSY);
				return;
			}
			var reqStr = {
				id: this.data.pid,
				op: yb_product.data.op1,
				vUid: YBApp.data.vUid,
			};
			var clickBtn = $("#borrow-btn");
			var showAni = true;
			if(isNotBlank(options)) {
				if(isNotBlank(options.id)) {
					reqStr.id = options.id;
				}
				if(isNotBlank(options.op)) {
					reqStr.op = options.op;
				}
				if(isNotBlank(options.showAni)) {
					showAni = options.showAni;
				}
				if(isNotBlank(options.clickBtn)) {
					//clickBtn = options.clickBtn;还没调成功
				}
			};
			ybAjaxGet(YBApp.URL.CART_BORROW_BOOK, reqStr, function(data) {
				if(isNotBlank(data) && data.success) {
					if(showAni) {
						addCartAni(clickBtn.offset(), function() {
							updaCartNum(data);
							eleScaleAni('cart-num-badge');
							YBApp.toast(true, "成功加入贝包",1000);
						});
					} else {
						updaCartNum(data);
						eleScaleAni('cart-num-badge');
						YBApp.toast(true, "成功加入贝包",1000);
					}
				} else {
					updaCartNum(data);
				}
			}, true);
		},
		deleteBorrow: function(options) {
			if(YBApp.connecting) {
				mui.toast(YBApp.Str.NETWORK_BUSY);
				return;
			}
			var reqStr = {
				id: this.data.pid,
				isBorrow: true,
				vUid: YBApp.data.vUid,
			};
			if(isNotBlank(options)) {
				reqStr.id = options.id;
			};
			ybAjaxGet(YBApp.URL.CART_DELETE, reqStr, function(data) {
				if(data.success) {
					updaCartNum(data);
					eleScaleAni('cart-num-badge');
					YBApp.toast(true, "已取消借阅",1000);
				} else {
					YBApp.toast(false, data.msg);
				}
			}, true);
		},
		borrowBookNotice: function(options) {
			if(YBApp.connecting) {
				mui.toast(YBApp.Str.NETWORK_BUSY);
				return;
			}
			var reqStr = {
				id: this.data.pid,
				type: 2
			};
			ybAjaxGet(YBApp.URL.USER_GOODS_ARRIVAL_NOTICE, reqStr, function(data) {
				mui.toast(data.msg);
			}, true);
		},
		addBuyCart: function(options) {
			if(YBApp.connecting) {
				mui.toast(YBApp.Str.NETWORK_BUSY);
				return;
			}
			var reqStr = {
				id: this.data.pid,
				num: 1,
				vUid: YBApp.data.vUid,
			};
			var showAni = true;
			if(isNotBlank(options)) {
				if(isNotBlank(options.id)) {
					reqStr.id = options.id;
				}
				if(isNotBlank(options.num)) {
					num = options.num;
				}
				if(isNotBlank(options.showAni)) {
					showAni = options.showAni;
				}
			};
			ybAjaxGet(YBApp.URL.CART_BUY_GOODS, reqStr, function(data) {
				if(isNotBlank(data) && data.success) {
					if(showAni) {
						addCartAni($("#buy-btn").offset(), function() {
							updaCartNum(data);
							eleScaleAni('cart-num-badge');
							YBApp.toast(true, "成功加入贝包",1000);
						});
					} else {
						updaCartNum(data);
						eleScaleAni('cart-num-badge');
						YBApp.toast(true, "成功加入贝包",1000);
					}
				} else {
					updaCartNum(data);
				}
			}, true);
		},
		favorte: function(options) {
			if(YBApp.connecting) {
				mui.toast(YBApp.Str.NETWORK_BUSY);
				return;
			}
			var reqStr = {
				id: this.data.pid,
				type: 'add',
			};
			if(isNotBlank(options)) {
				if(isNotBlank(options.id)) {
					reqStr.id = options.id;
				}
				if(isNotBlank(options.type)) {
					reqStr.type = options.type;
				}
			};

			ybAjaxGet(YBApp.URL.BOOK_FAVORITE, reqStr, function(data) {
				if(!isNotBlank(data)) {
					mui.toast(YBApp.Str.NETWORK_BUSY);
					return;
				}
				if(data.success) {
					if(reqStr.type == 'add') {
						removeClass('favorite-btn-icon', 'nofavorite-icon');
						addClass('favorite-btn-icon', 'favorite-icon');
						setEleText('favorte-btn-text', '已收藏');
						yb_product.data.isFavorite = true;
						eleScaleAni('favorite-btn-icon');
					} else {
						removeClass('favorite-btn-icon', 'favorite-icon');
						addClass('favorite-btn-icon', 'nofavorite-icon');
						setEleText('favorte-btn-text', '收藏');
						yb_product.data.isFavorite = false;
					}

				} else {
					if(data.code == 301) {
						YBApp.openWindow('/login.html');
					} else {
						YBApp.toast(false, data.msg);
					}
				}
			}, true);
		},
		eventInit: function() {
			getEle('buy-btn').addEventListener('tap', function() {
				if(this.classList.contains('btn-disable')) {
					return;
				}
				yb_product.addBuyCart({
					showAni: false,
					num: 1
				});
			});
			getEle('borrow-btn').addEventListener('tap', function() {
				if(this.classList.contains('btn-disable')) {
					return;
				}
				if(this.classList.contains('btn-cancel')) {
					yb_product.deleteBorrow();
				} else if(this.classList.contains('arrival-notice-btn')) {
					yb_product.borrowBookNotice();
				} else {
					yb_product.addBorrowCart({
						showAni: false
					});
				}
			});
			getEle('favorite-btn').addEventListener('tap', function() {
				if(yb_product.data.isFavorite) {
					yb_product.favorte({
						type: 'delete'
					});
				} else {
					yb_product.favorte({
						type: 'add'
					});
				}
			});
			getEle('beibao-btn').addEventListener('tap', function() {
				setSessionStorage("showtab", "baobao");
				YBApp.openWindow("/index.html");
			});
			getEle('goIndex').addEventListener('tap', function() {
				setSessionStorage("showtab", "index");
				YBApp.openWindow("/index.html");
			})
			var optionsWin = new mui.PopPicker();
			mui('.quick-entry-nav').on('tap', 'button', function() {
				if(this.classList.contains('btn-disable')) {
					return;
				};
				var id = this.value;
				var clicBtn = $(this);
				if(this.classList.contains('btn-cancel')) {
					yb_product.deleteBorrow({
						id: id,
					});
				} else {
					var bReq = {
						id: id
					};
					ybAjaxGet(YBApp.URL.BOOK_MYSHORTITEM, bReq, function(json) {
						if(!isNotBlank(json)) {
							mui.toast(YBApp.Str.NETWORK_BUSY);
							return;
						}
						if(json.success) {
							optionsWin.setData(json.data);
							optionsWin.show(function(item) {
								if(isNotBlank(item)) {
									yb_product.addBorrowCart({
										id: id,
										op: item,
										clickBtn: clicBtn,
										showAni: false
									});
								}
							});
						} else {
							if(json.code == 301) {
								YBApp.openWindow('/login.html');
							} else {
								YBApp.toast(false, json.msg);
							}
						}
					}, true);
				}
			});
			mui('#product_comment').on('tap', '.assess-like-btn', function() {
				if(this.firstChild.classList.contains('icon-likedsmall')) {
					return;
				}
				var reqStr = {
					cid: this.id
				};
				var ele = this;
				ybAjaxGet(YBApp.URL.BOOK_COMMENT_LIKE, reqStr, function(data) {
					if(!isNotBlank(data)) {
						return;
					}
					if(data.success) {
						ele.firstChild.classList.remove('icon-likesmall');
						ele.firstChild.classList.add('icon-likedsmall');
						ele.lastChild.innerText = data.data.num;
						eleScaleAni(ele.firstChild.id);
					} else {
						if(data.code == 301) {
							YBApp.openWindow('/login.html');
						} else {
							YBApp.toast(false, data.msg);
						}
					}
				}, true);
			});
			mui('#lendBookOption').on('tap', 'button', function() {
				if(this.classList.contains('mui-btn-unable-select') || this.classList.contains('mui-btn-selected')) {
					return;
				}
				var opId = this.getAttribute('data-id');
				yb_product.data.op1 = opId;
				var selected = this.parentNode.querySelector(".mui-btn-selected");
				if(isNotBlank(selected)) {
					var classList = selected.classList;
					classList.remove('mui-btn-selected');
					classList.add('mui-btn-enable-select');
				}
				this.classList.remove('mui-btn-enable-select');
				this.classList.add('mui-btn-selected');

				var opRental = this.getAttribute('data-rental');
				var opDRental = this.getAttribute('data-dRental');
				setEleText('item-rental', opRental);
				setEleText('item-rental-1', opRental);
				setEleText('item-vipRental', opDRental);
			});
			var m = document.querySelectorAll(".detail");
			aTabLstA = document.querySelectorAll(".tab-lst-a");
			for(var n = 0; n < m.length; n++) {
				m[n].style.display = "none"
			}
			m[0].style.display = "block";
			for(var n = 0; n < aTabLstA.length; n++) {
				(function(o) {
					aTabLstA[n].addEventListener("tap", function() {
						for(var p = 0; p < m.length; p++) {
							m[p].style.display = "none"
						}
						for(var q = 0; q < aTabLstA.length; q++) {
							if(aTabLstA[q].classList.contains("on")) {
								aTabLstA[q].classList.remove("on")
							}
						}
						aTabLstA[o].classList.add("on");
						var r = aTabLstA[o].getAttribute("value");
						document.getElementById(r).style.display = "block"
					}, false)
				}(n))
			}
			getEle('pj-more').addEventListener('tap', function() {
				var controlItems = document.querySelectorAll('#segmentedControl .mui-control-item')
				for(var i = 0, len = controlItems.length; i < len; i++) {
					controlItems[i].classList.remove('mui-active');
				}
				var controlContents = document.querySelectorAll('.mui-content .mui-control-content');
				for(var i = 0, len = controlContents.length; i < len; i++) {
					controlContents[i].classList.remove('mui-active');
				}
				addClass('pj-control', 'mui-active');
				addClass('product_comment', 'mui-active');
			});
			var config = {
				url: 'http://m.17yuebei.com',
				title: '约贝童书绘本借阅平台',
				desc: '我在使用约贝，海量童书绘本可借可买，在线借阅实惠、方便、卫生，邀请你一起来体验',
				img: 'http://m.17yuebei.com/icon/Icon-128.png',
				img_title: '约贝',
				from: '约贝'
			};
			//跟选择借书等级的PopPicker冲突，待优化 TODO
//			var shareWin = new mui.PopPicker(config);
//			getEle('share-btn').addEventListener('tap', function() {
//				shareWin.show();
//			});
		}
	};

	function lendBookOptionInit(jo) {
		if(!isNotBlank(jo)) {
			return;
		}
		var innerHtml = '';
		if(isNotBlank(jo.op1)) {
			innerHtml += '<div class="yb-title-text-pormpt-small">' + jo.op1.name + '</div>';
			innerHtml += '<span class="mui-pull-left">';
			var ops = jo.op1.op;
			mui.each(ops, function(idx, obj) {
				var ev;
				var classl = '';
				var rentalS = '';
				var dRentalS = '';
				try {
					ev = eval('jo.stock.p_' + obj.id + '_0');
					if(isNotBlank(ev) && ev.enable) {
						if(ev.selected) {
							yb_product.data.op1 = obj.id;
							classl = 'mui-btn mui-btn-selected';
							setEleText('item-rental', ev.rentalS);
							setEleText('item-rental-1', ev.rentalS);
							setEleText('item-vipRental', ev.DRentalS);
						} else {
							classl = 'mui-btn mui-btn-enable-select';
						}
						rentalS = ev.rentalS;
						dRentalS = ev.DRentalS;
					} else {
						classl = 'mui-btn mui-btn-unable-select';
					}
					innerHtml += '<button type="button" data-id="' + obj.id + '" data-rental="' + rentalS + '" data-dRental="' + dRentalS + '" class="' + classl + '">' + obj.name + '</button>';
				} catch(e) {}
			});
			innerHtml += '</span>';
		}
		return innerHtml;
	}

	function htmlRecommend(list) {
		var html = [];
		mui.each(list, function(idx, obj) {
			html.push('<div class="detail swiper-slide">');
			html.push('<a class="detail swiper-slide" href="/item/' + obj.fileUrl + '">');
			html.push('<div class="goods_img_size">');
			html.push('<img class="swiper-lazy" src="/images/product/s300x300/' + obj.icon + '">');
			html.push('</div>');
			html.push('<div class="name">' + obj.name + '</div>');
			html.push('</a>');
			html.push('</div>');
		});
		return html.join('');
	}

	function goodsComment(jsonObj) {
		if(!isNotBlank(jsonObj)) {
			return;
		}
		var innerStr = '<li class="mui-table-view-cell">';
		if(isNotBlank(jsonObj.userIcon)) {
			innerStr += '<img class="mui-pull-left yb-user-icon-small" src="../images/headicon/' + jsonObj.userIcon + '" />';
		} else {
			innerStr += '<img class="mui-pull-left yb-user-icon-small" src="../icon/default-user-icon.png" />';
		}
		innerStr += '<span class="text-black2-color comment-name">';
		innerStr += jsonObj.userName;
		innerStr += '</span><span class="mui-pull-right yb-title-text-pormpt-small">';
		innerStr += jsonObj.dateShow;
		innerStr += '</span>';
		innerStr += '</li><li class="mui-table-view-cell">';
		innerStr += '<span class="pj-s-cont" style="margin-top:-8px;margin-bottom:5px">';
		for(var i = 0; i < 5; i++) {
			if(i < jsonObj.star) {
				innerStr += '<span class="pj-star-icon on">星星</span>';
			} else {
				innerStr += '<span class="pj-star-icon">星星</span>';
			}
		}
		innerStr += '</span>';
		innerStr += '<div class="pj-content">';
		innerStr += jsonObj.content;
		innerStr += '</div><div class="quick-entry-nav">';
		var pics = jsonObj.pics;
		mui.each(pics, function(idx, obj) {
			innerStr += '<span class="quick-entry-link" style="padding-bottom: 0px;">';
			innerStr += '<img src="../images/comment/s100x100/' + obj.pic + '" data-preview-src="../images/comment/large/' + obj.pic + '" data-preview-group="' + jsonObj.commentId + '">';
			innerStr += '</span>';
		});
		innerStr += '</div></li><li class="mui-table-view-divider" style="padding: 0px;">';
		innerStr += '<div class="assess-btns-box"><div class="assess-btns">';
		innerStr += '<a id="' + jsonObj.commentId + '" class="assess-like-btn text-black3-color">';
		if(jsonObj.like) {
			innerStr += '<i id="like' + jsonObj.commentId + '" class="icon icon-likedsmall" style="margin-top: 5px;"></i>';
		} else {
			innerStr += '<i id="like' + jsonObj.commentId + '" class="icon icon-likesmall" style="margin-top: 5px;"></i>';
		}
		innerStr += '<span class="assess-btns-num">' + jsonObj.likes + '</span>';
		innerStr += '</a>';
		//	innerStr += '<i class="line-gradient"></i><a href="replyList.jsp?cid=' + jsonObj.commentId + '" class="assess-reply-btn text-black3-color">';
		//	innerStr += '<span class="mui-icon mui-icon-chat"></span><em class="assess-btns-num">(' + jsonObj.replies + ')</em></a>';
		innerStr += '</div></div></li>';
		return innerStr;
	}

	function shortPJ(jsonObj) {
		if(!isNotBlank(jsonObj)) {
			return;
		}
		var innerStr = '<div style="margin-top:-8px;margin-bottom:5px">';
		for(var i = 0; i < 5; i++) {
			if(i < jsonObj.star) {
				innerStr += '<span class="pj-star-icon on">星星</span>';
			} else {
				innerStr += '<span class="pj-star-icon">星星</span>';
			}
		}
		innerStr += '<span class="text-black2-color comment-name mui-pull-right ">';
		innerStr += jsonObj.userName;
		innerStr += '</span>';
		innerStr += '</div>';
		innerStr += '<div class="pj-content ellipsis-3">';
		innerStr += jsonObj.content;
		innerStr += '</div><div class="quick-entry-nav">';
		var pics = jsonObj.pics;
		mui.each(pics, function(idx, obj) {
			innerStr += '<span class="quick-entry-link" style="padding-bottom: 0px;">';
			innerStr += '<img src="../images/comment/s100x100/' + obj.pic + '" data-preview-src="../images/comment/large/' + obj.pic + '" data-preview-group="s' + jsonObj.commentId + '">';
			innerStr += '</span>';
		});
		innerStr += '</div>';
		return innerStr;
	}

	function updaCartNum(jsonObj) {
		if(!isNotBlank(jsonObj)) {
			return;
		}
		if(jsonObj.success) {
			var r = jsonObj.data;
			if(isNotBlank(r)) {
				setEleText('cart-buy-num', r.buyNum);
				setEleText('cart-borrow-num', r.borrowNum);
				setEleText('cart-total-num', r.total);
				var borrowGoods = r.borrowList;
				var borrowedBookID = '';
				if(isNotBlank(borrowGoods)) {
					mui.each(borrowGoods, function(idx, obj) {
						borrowedBookID += ',' + obj.id;
					});
				}
				yb_product.data.borrowedBookID = borrowedBookID;
				updateBuyAndBorrowButtonStatus();
			}
		} else {
			if(isNotBlank(jsonObj.msg)) {
				mui.toast(jsonObj.msg);
			}
		}
	};

	function updateBuyAndBorrowButtonStatus() {
		if(yb_product.data.goodsStatus != 1 || !yb_product.data.saleAble || yb_product.data.saleStock <= 0) {
			addClass('buy-btn', 'btn-disable');
			setEleHtml('buy-btn-text', '已售完');
		}
		removeClass('borrow-btn', 'btn-disable');
		removeClass('borrow-btn', 'btn-cancel');
		if(yb_product.data.borrowedBookID.indexOf(yb_product.data.pid.toString()) >= 0) {
			addClass('borrow-btn', 'btn-cancel');
			setEleHtml('borrow-btn-text', '取消借');
		} else if(yb_product.data.goodsStatus != 1 || !yb_product.data.lendAble || yb_product.data.lendStock <= 0) {
			addClass('borrow-btn', 'arrival-notice-btn');
			setEleHtml('borrow-btn-text', '有书通知');
		} else {
			setEleHtml('borrow-btn-text', '借&nbsp;阅');
		}

		//系列图书按钮
		if(getEleBooleanVal('h-isSerices')) {
			var sericesBookBorrowCount = 0;
			mui("#serices-div button").each(function() {
				var gStatus = this.getAttribute('data-gstatus');
				var lendAble = parseBoolean(this.getAttribute('data-lendable'));
				var lendStock = this.getAttribute('data-lendstock');
				this.classList.remove('btn-cancel');
				this.classList.remove('btn-disable');
				if(isNotBlank(yb_product.data.borrowedBookID) && yb_product.data.borrowedBookID.indexOf(this.value) >= 0) {
					sericesBookBorrowCount++;
					this.classList.add('btn-cancel');
					this.innerHTML = '取消借';
				} else if(gStatus != 1 || !lendAble || lendStock <= 0) {
					this.classList.add('btn-disable');
					this.innerHTML = '已借光';
				} else {
					this.innerHTML = '借&nbsp;阅';
				}
			});
			yb_product.data.sericesBorrowedCount = sericesBookBorrowCount;
			setEleText('serices-borrowed-count', sericesBookBorrowCount);
		}
	}

	function eleScaleAni(eleId) {
		addClass(eleId, 'scale-ani');
		setTimeout(function() {
			removeClass(eleId, 'scale-ani');
		}, 1000);
	}

	var offset = $("#fly-end").offset();

	function addCartAni(event, onCallBack) {
		var flyer = $('<img class="u-flyer" src="../images/product/large/' + getEleVal('h-icon') + '">');
		flyer.fly({
			start: {
				left: event.left, //开始位置（必填）#fly元素会被设置成position: fixed 
				top: event.top //开始位置（必填） 
			},
			end: {
				left: offset.left + 40, //结束位置（必填） 
				top: offset.top, //结束位置（必填） 
				width: 0, //结束时宽度 
				height: 0 //结束时高度 
			},
			onEnd: function() { //结束回调 
				flyer.remove();
				onCallBack.call(this);
			}
		});
	};
})();