mui.ready(function() {

	getEle("order-confirm-btn").addEventListener('tap', function() {
		ybAjaxGet(YBApp.URL.ORDER_CREATE, null, function(jsonObj) {
			if (jsonObj.success) {
				YBApp.openWindow('/order/payment.html?orderNo=' + jsonObj.data.orderNo);
				return;
			} else {
				if (jsonObj.code == 301) {
					YBApp.openWindow('/login.html');
				} else {
					if (isNotBlank(jsonObj.msg)) {
						YBApp.alert.show(jsonObj.msg);
//						YBApp.toast(false, jsonObj.msg);
					}
				}
			}
		}, true);
	});
	getEle("beibi-help").addEventListener('tap', function() { //TODO
		YBApp.alert.show('1.订单金额大于20元<br/>2.贝币数量大于1000<br/>3.贝币支付不得超过每笔订单应付金额的50%<br/>4.使用贝币数量为1000的整数倍<br/>5.100贝币抵1元', '贝币使用规则', null);
	});
	getEle('order-address').addEventListener('tap', function() {
		if (getEle('showAddress').classList.contains("mui-hidden")) {
			YBApp.openWindow('/order/createAddress.html');
		} else {
			setCookie('oaddress', getEleVal('oaddress'), 1);
			YBApp.openWindow('/order/selectAddress.html');
		}
	});
	getEle('order-borrow-book').addEventListener('tap', function() {
		YBApp.openWindow('/order/orderItems.html');
	});
	getEle('order-buy-goods').addEventListener('tap', function() {
		YBApp.openWindow('/order/orderItems.html');
	});
	getEle('order-courier').addEventListener('tap', function() {
		setCookie('ocurier', getEleVal('courier'), 1);
		YBApp.openWindow('/order/selectCourier.html');
	});
	getEle('order-yb-coupon').addEventListener('tap', function() {
		var vailableCouponNum = getEleVal('vailableCouponNum');
		if (vailableCouponNum == 0) {
			return;
		}
		setCookie('ocoupon', getEleVal('ocoupon'), 1);
		YBApp.openWindow('/order/selectCoupon.html');
	});
	//	getEle('order-deliverydate').addEventListener('tap', function() {
	//
	//		YBApp.openWindow('selectDeliveryDate.html');
	//	});
	getEle('order-yb-beibi').addEventListener('tap', function() {
		var maxUseBeiBiCount = getEleVal('maxUseBeiBi');
		if (maxUseBeiBiCount == 0) {
			return;
		}
		var beibiSelectData = new Array();
		var t = {
			value: 0,
			text: '不使用'
		};
		beibiSelectData[0] = t;
		var j = 1;
		for (var i = 1000; i <= maxUseBeiBiCount;) {
			t = {
				value: i,
				text: i + '贝币'
			};
			beibiSelectData[j] = t;
			i = i + 1000;
			j++;
		}
		var userPicker = new mui.PopPicker();
		userPicker.setData(beibiSelectData);
		userPicker.show(function(items) {
			var reqStr = {
				biebiCost: items[0].value,
			};
			ybAjaxGet(YBApp.URL.ORDER_UPDATE_BEIBICOST, reqStr, initOrderInfo, true);
		});
	});
});

ybAjaxGet(YBApp.URL.ORDER_GET_PREORDER, null, initOrderInfo, true, function() {
	hideEle('order-content');
	showEle('order-empty');
});

function initOrderInfo(jsonObj) {
	if (jsonObj.success) {
		hideEle('beibeiDecMoney');
		hideEle('couponDecMoney');
		hideEle('discountAmountLi');
		removeClass('order-confirm-btn', 'mui-disabled');

		var r = jsonObj.data;
		setEleText('consignee', r.consignee);
		setEleText('phone', r.phone);
		setEleText('address', r.address);
		setEleVal('oaddress', r.addressId)
		if (r.addressId == 0) {
			hideEle('showAddress');
			showEle('waringAddress');
		}

		setEleText('couries-show', r.sendCourierName);
		setEleText('beibicount', r.beibiCount);
		if (r.beibiCost > 0) {
			setEleText('beibicost', '使用' + r.beibiCost + '贝币，抵¥' + r.beibiConvertMoneyShow);
		} else if (r.maxUseBeiBiCount > 0) {
			setEleText('beibicost', '可使用' + r.maxUseBeiBiCount + '贝币');
		}
		if (r.couponConvertMoney > 0) {
			setEleText('couponCost', '使用优惠券抵¥' + r.couponConvertMoneyShow);
		} else if (r.vailableCouponNum > 0) {
			setEleHtml('couponCost', '<div class="word-backgroud-color">' + r.vailableCouponNum + '张可用</div>');
		}

		setEleVal('maxUseBeiBi', r.maxUseBeiBiCount);
		setEleVal('courier', r.sendCourier);
		setEleVal('ocoupon', r.couponId);
		setEleVal('vailableCouponNum', r.vailableCouponNum);
		if (r.beibiConvertMoney > 0) {
			showEle('beibeiDecMoney');
			setEleText('beibiConvertMoney', r.beibiConvertMoneyShow);
		}
		if (r.couponConvertMoney > 0) {
			showEle('couponDecMoney');
			setEleText('couponConvertMoney', r.couponConvertMoneyShow);
		}
		if (r.discountAmount > 0) {
			showEle('discountAmountLi');
			setEleText('discountAmountShow', r.discountAmountShow);
		}
		if (r.borrowDiscountAmount > 0) {
			showEle('borrowDiscountLi');
			setEleText('borrowDiscountShow', r.borrowDiscountS + '折');
			setEleText('borrowDiscountAmountShow', r.borrowDiscountAmountS);
		}
		if(isNotBlank(r.btAlert)){
			showEle('btAlert-li');
			setEleHtml('btAlert',r.btAlert);
		}
		setEleText('freight', r.freightShow);
		setEleText('amount', r.amountShow);
		setEleText('accountPayable', r.accountPayableShow);
		var borrowList = r.borrowList;
		var buyList = r.buyList;
		var borrowHtml = "";
		var buyHtml = "";
		var borrowCount = 0;
		var buyCount = 0;
		mui.each(borrowList, function(idx, obj) {
			if (borrowCount < 4) {
				borrowHtml += '<img class="yb-img" src="../images/product/s300x300/' + obj.icon + '">';
			}
			borrowCount = borrowCount + obj.num;
		});
		mui.each(buyList, function(idx, obj) {
			if (buyCount < 4) {
				buyHtml += '<img class="yb-img" src="../images/product/s300x300/' + obj.icon + '">';
			}
			buyCount = buyCount + obj.num;
		});
		if (borrowCount > 0) {
			showEle('order-borrow-book');
			setEleText('order-borrow-count', borrowCount);
			setEleHtml('order-borrow-ele', borrowHtml);
		}
		if (buyCount > 0) {
			showEle('order-buy-goods');
			setEleText('order-buy-count', buyCount);
			setEleHtml('order-buy-ele', buyHtml);
		}

		var maxUseBeiBiCount = r.maxUseBeiBiCount;

	} else {
		if (jsonObj.code == 301) {
			YBApp.openWindow('/login.html');
		} else {
			hideEle('order-content');
			showEle('order-empty');
			if (isNotBlank(jsonObj.msg)) {
				YBApp.toast(false, jsonObj.msg);
			}
		}
	}
}