(function() {
	var myMoney = 0;
	var residualAmountPay = 0;
	var setPayPass = false;
	var orderNo = getQueryString("orderNo");
	var reqStr = {
		orderNo: orderNo
	};

	var pays = {};
	if(mui.os.plus) {
		document.addEventListener('plusready', plusReady, false);

		function plusReady() {
			// 获取支付通道
			plus.payment.getChannels(function(channels) {
				for(var i in channels) {
					var channel = channels[i];
					pays[channel.id] = channel;
					checkServices(channel);
				}
			}, function(e) {});
		}
	}
	ybAjaxGet(YBApp.URL.ORDER_GET_UNPAID_ORDER, reqStr, payDetail, true);

	getEle('pay-confirm-btn').addEventListener('tap', function() {
		if(getEle('moneyPayCB').checked) {
			if(setPayPass) {
				moneyPayConfirm();
			} else {
				YBApp.confirm.show('使用约贝余额支付需要先设置支付密码，您还没设置支付密码', function(e) {
					if(e.index == 1) {
						setCookie('payPassReturn', YBApp.data.curUrl, 1);
						YBApp.openWindow("/my/setPayPass.html");
					}
				}, ['取消', '去设置密码']);
			}
		} else {
			thirdPartyPay();
		}
	});

	function moneyPayConfirm() {
		YBApp.prompt.show("为了您的资金安全，请输入约贝余额支付密码", "password", function(r) {
			if(r.index == 0) {
				return;
			}
			if(!isNotBlank(r.value)) {
				YBApp.toast(false, "请输入支付密码");
				return;
			}
			if(r.value.length < 6 || r.value.length > 10) {
				YBApp.toast(false, "支付密码格式错误");
				return;
			}
			if(!isNumWord(r.value)) {
				YBApp.toast(false, "支付密码由数字或字母组成");
				return;
			}
			var payPass = hex_md5(r.value);
			var reqStr = {
				orderNo: orderNo,
				payPass: payPass
			};
			ybAjaxGet("/services/order/moneyPay", reqStr, function(jsonObj) {
				if(jsonObj.success) {
					if(jsonObj.data.needThirdPartyPay) {
						thirdPartyPay();
					} else {
						YBApp.openWindow('/order/paySuccess.html?orderNo=' + orderNo);
					}
				} else {
					if(jsonObj.code == 301) {
						YBApp.openWindow('/login.html');
					} else {
						if(isNotBlank(jsonObj.msg)) {
							YBApp.toast(false, jsonObj.msg);
						}
					}
				}
			}, true);
		})
	}

	function thirdPartyPay() {
		if(getEle('weixinPayCB').checked) {
			if(mui.os.plus) { //app
				plusPayChannel('wxpay');
			} else if(mui.os.wechat) { //微信客户端
				ybAjaxGet(YBApp.URL.WX_GET_OPENID, reqStr, function(jsonObj) {
					if(jsonObj.success) {
						YBApp.openWindow('/order/wxPayWait.html?orderNo=' + orderNo + '&openid=' + jsonObj.data.openid);
					} else {
						if(jsonObj.code == 301) {
							YBApp.openWindow('/login.html');
						} else if(jsonObj.code == 501) {
							YBApp.openWindow(jsonObj.data.url);
						} else {
							if(isNotBlank(jsonObj.msg)) {
								YBApp.toast(false, jsonObj.msg);
							}
						}
					}
				}, true);
			} else { //手机浏览器

			}
		} else if(getEle('aliPayCB').checked) {
			if(mui.os.plus) { //app
				plusPayChannel('alipay');
			} else if(mui.os.wechat) { //微信客户端

			} else { //手机浏览器
				ybAjaxGet("/services/alipay/getPayRequestContentForH5", reqStr, function(jsonObj) {
					if(jsonObj.success) {
						var div = document.createElement("div");
						div.innerHTML = jsonObj.data.req;
						document.body.appendChild(div);
						//appendChild进去的submit()没有起到效果，所以下面再执行一下
						document.forms[0].submit();
					} else {
						if(jsonObj.code == 301) {
							YBApp.openWindow('/login.html');
						} else {
							if(isNotBlank(jsonObj.msg)) {
								YBApp.toast(false, jsonObj.msg);
							}
						}
					}
				}, true);
			}
		} else if(getEle('unionPayCB').checked) {

		}
	}
	getEle('allOrderBtn').addEventListener('tap', function() {
		YBApp.confirm.show('您确定要离开收银台吗？下单后24小时内未支付成功，订单将被取消，请尽快完成支付', function(e) {
			if(e.index == 0) {
				YBApp.openWindow("/my/allOrder.html");
			}
		}, ['确定离开', '继续支付']);
	});

	mui('#payment-content').on('change', 'input', function() {
		var id = this.id;
		if(isContains(id, 'moneyPayCB')) {
			getEle('weixinPayCB').checked = false;
			getEle('aliPayCB').checked = false;
			getEle('unionPayCB').checked = false;
			initShow();
		} else {
			if(myMoney >= residualAmountPay) {
				getEle('moneyPayCB').checked = false;
			}
			var checked = this.checked;
			if(!checked) {
				this.checked = true;
			} else {
				getEle('weixinPayCB').checked = false;
				getEle('aliPayCB').checked = false;
				getEle('unionPayCB').checked = false;
				this.checked = checked;
			}
			initShow();
		}
	});

	function payDetail(jsonObj) {
		if(jsonObj.success) {
			var r = jsonObj.data;
			setEleText('myMoney', r.myMoneyShow);
			setEleText('accountPayable', r.residualAmountPayS);
			setPayPass = r.setPayPass;
			residualAmountPay = r.residualAmountPay;
			myMoney = r.myMoney;
			if(r.myMoney <= 0) {
				showEle('noMoneyPay');
				hideEle('moneyPay');
			} else {
				showEle('moneyPay');
				hideEle('noMoneyPay');
				getEle('moneyPayCB').checked = true;
			}
			initShow();
		} else {
			if(jsonObj.code == 301) {
				YBApp.openWindow('/login.html');
			} else {
				if(isNotBlank(jsonObj.msg)) {
					showEle('payment-error');
					hideEle('payment-content');
				}
			}
		}
	}

	function initShow() {
		var balancePayMoney = 0;
		var thirdPartyPayMoney = 0;
		if(myMoney > 0 && getEle('moneyPayCB').checked) {
			if(myMoney >= residualAmountPay) {
				balancePayMoney = residualAmountPay;
			} else {
				balancePayMoney = myMoney;
			}
		}
		thirdPartyPayMoney = residualAmountPay - balancePayMoney;
		setEleText('balancePayMoney', balancePayMoney.formatMoney(2, "", ",", "."));
		setEleText('thirdPartyPayMoney', thirdPartyPayMoney.formatMoney(2, "", ",", "."));

		if(thirdPartyPayMoney > 0 && !getEle('weixinPayCB').checked && !getEle('aliPayCB').checked && !getEle('unionPayCB').checked) {
			var wxd = jQuery('#weixinPay').css('display');
			var alid = jQuery('#aliPay').css('display');
			var uniond = jQuery('#unionPay').css('display');
			if(!isContains(wxd, 'none')) {
				getEle('weixinPayCB').checked = true;
			} else if(!isContains(alid, 'none')) {
				getEle('aliPayCB').checked = true;
			} else if(!isContains(uniond, 'none')) {
				getEle('unionPayCB').checked = true;
			}
		}
	}

	function plusPayChannel(channelId) {
		var payChannel = pays[channelId];
		checkServices(payChannel);
		var URL = "";
		if(channelId.indexOf('alipay') >= 0) {
			URL = YBApp.URL.ALIPAY_GET_PAYREQCONFORAPP;
		} else if(channelId.indexOf('wxpay') >= 0) {
			URL = YBApp.URL.WX_GET_BRANDPAYJSON;
		}
		ybAjaxGet(URL, {
			orderNo: orderNo
		}, function(jsonObj) {
			if(jsonObj.success) {
				var r = jsonObj.data;
				var data = r.req;
				//YBApp.alert.show(data);
				plus.payment.request(payChannel, data, function(result) {
					YBApp.openWindow(r.url);
				}, function(e) {
					YBApp.alert.show("支付失败，请稍后重试或选择其他支付方式");
//					YBApp.alert.show("[" + e.code + "]：" + e.message);
				});
			} else {
				if(jsonObj.code == 301) {
					YBApp.openWindow('/login.html');
				} else {
					if(isNotBlank(jsonObj.msg)) {
						YBApp.toast(false, jsonObj.msg);
					}
				}
			}
		}, true);
	}

	function checkServices(pc) {
		if(!pc.serviceReady) {
			var txt = null;
			switch(pc.id) {
				case "alipay":
					txt = "系统未安装“支付宝快捷支付服务”，无法完成支付操作，是否立即安装？";
					break;
				default:
					txt = "系统未安装“" + pc.description + "”服务，无法完成支付，是否立即安装？";
					break;
			}
			plus.nativeUI.confirm(txt, function(e) {
				if(e.index == 0) {
					pc.installService();
				}
			}, pc.description);
		}
	}
	mui.back = function() {
		YBApp.confirm.show('您确定要离开收银台吗？下单后24小时内未支付成功，订单将被取消，请尽快完成支付', function(e) {
			if(e.index == 0) {
				YBApp.openWindow("/my/allOrder.html");
			}
		}, ['确定离开', '继续支付']);
	}
}())