(function() {
	search = {
		init: function(op) {
			var d = op || {};
			this.data.refreshUrl = d.refreshUrl;
			this.data.listReqPara = d.reqPara;
			this.data.optionsWin = new mui.PopPicker();
			this.loadCart();
		},
		data: {
			optionsWin: null,
			page: 0,
			totalCount: 0,
			listReqPara: null,
			refreshUrl: "",
			borrowId: ""
		},
		loadCart: function() {
			var reqStr = {
				vUid: YBApp.data.vUid,
			};
			ybAjaxGet(YBApp.URL.CART_DETAIL, reqStr, function(data) {
				updateBorrowId(data);
				var pull = mui('#comment-scroll').pullRefresh();
				pull.pullupLoading();
			}, true);
		},
		loadList: function() {
			search.data.listReqPara.page = search.data.page;
			ybAjaxGet(search.data.refreshUrl, search.data.listReqPara, function(jsonObj) {
				if(!isNotBlank(jsonObj)) {
					return;
				}
				var pull = mui('#comment-scroll').pullRefresh();
				if(jsonObj.success) {
					search.data.page += 1;
					var resultArray = jsonObj.data;
					var ulContent = getEle('listDiv');
					mui.each(resultArray, function(idx, obj) {
						search.data.totalCount += 1;
						var li = document.createElement('li');
						li.setAttribute('data-pid', obj.goodsId);
						li.className = 'mui-table-view-cell';
						li.innerHTML = bookDetail(obj);
						ulContent.appendChild(li);
					});
					if(search.data.totalCount == 0) {
						showEle('no-content');
						hideEle('comment-scroll')
						pull.bottomPocket.classList.add("mui-hidden");
					}
					pull.endPullupToRefresh(resultArray.length < 10); //参数为true代表没有更多数据了。
				} else {
					showEle('no-content');
					hideEle('comment-scroll')
					pull.bottomPocket.classList.add("mui-hidden");
					pull.endPullupToRefresh(true);
					if(isNotBlank(jsonObj.msg)) {
						mui.toast(jsonObj.msg);
					}
				}
			}, true);
		},
		showBorrowOp: function(self, reqStr) {
			ybAjaxGet(YBApp.URL.BOOK_MYSHORTITEM, reqStr, function(json) {
				if(!isNotBlank(json)) {
					mui.toast(YBApp.Str.NETWORK_BUSY);
					return;
				}
				if(json.success) {
					search.data.optionsWin.setData(json.data);
					search.data.optionsWin.show(function(item) {
						if(isNotBlank(item)) {
							var opReqStr = {
								id: reqStr.id,
								op: item,
								vUid: YBApp.data.vUid,
							};
							search.addBorrowCart(self, opReqStr);
						}
					});
				} else {
					YBApp.toast(false, json.msg);
				}
			}, true);
		},
		deleteBorrow: function(self, reqStr) {
			ybAjaxGet(YBApp.URL.CART_DELETE, reqStr, function(data) {
				if(data.success) {
					YBApp.toast(true, "已取消借阅");
					self.classList.remove("btn-cancel");
					self.innerText = "借阅";
				} else {
					YBApp.toast(false, data.msg);
				}
			}, true);
		},
		addBorrowCart: function(self, reqStr) {
			ybAjaxGet(YBApp.URL.CART_BORROW_BOOK, reqStr, function(data) {
				if(isNotBlank(data) && data.success) {
					YBApp.toast(true, "成功加入贝包");
					self.classList.add("btn-cancel");
					self.innerText = "取消借";
				} else {
					YBApp.toast(false, data.msg);
				}
			}, true);
		}
	}

	function updateBorrowId(jsonObj) {
		if(jsonObj.success) {
			var r = jsonObj.data;
			if(isNotBlank(r)) {
				var borrowGoods = r.borrowList;
				var borrowedBookID = '';
				if(isNotBlank(borrowGoods)) {
					mui.each(borrowGoods, function(idx, obj) {
						borrowedBookID += ',' + obj.id;
					});
				}
				search.data.borrowId = borrowedBookID;
			}
		}
	};

	function bookDetail(obj) {
		var html = [];

		html.push('<div class="mui-media-body">');
		html.push('<a href="/item/' + obj.fileUrl + '">')
		html.push('<img class="mui-media-object mui-pull-left" style="max-width: 100px;width:100px;height: 100px;" src="../images/product/s300x300/' + obj.icon + '">');
		html.push('<p class="yb-product-detail-name">' + obj.name + '</p>');
		html.push('<div>');
		html.push('<p class="yb-product-detail-info">适读年龄:' + obj.forAgeStr + '</p>');
		html.push('<p class="yb-product-detail-info">主题:' + obj.themeStr + '</p>');
		html.push('</a>');
		html.push('</div>');
		html.push('<div>');
		if(obj.borrowTimes > 0) {
			html.push('<span class="yb-mui-badge yb-mui-badge-green">借阅过</span>');
		}
		if(isNotBlank(search.data.borrowId) && search.data.borrowId.indexOf(obj.id) >= 0) {
			html.push('<button type="button" value="' + obj.id + '" class="mui-btn mui-btn-success mui-btn-outlined mui-pull-right btn-cancel" style="padding:3px 8px">取消借</button>');
		} else
		if(obj.lendAble == 0 || obj.lendStock == 0) {
			html.push('<button type="button" value="' + obj.id + '" class="mui-btn mui-btn-success mui-btn-outlined mui-pull-right btn-disable" style="padding:3px 8px">已借光</button>');
		} else {
			html.push('<button type="button" value="' + obj.id + '" class="mui-btn mui-btn-success mui-btn-outlined mui-pull-right" style="padding:3px 8px">借阅</button>');
		}
		html.push('</div>');
		html.push('</div>');
		return html.join('');
	};

	mui('#listDiv').on('tap', 'button', function() {
		var self = this;
		if(this.classList.contains('btn-disable')) {
			return;
		};
		var id = this.value;
		if(this.classList.contains('btn-cancel')) {
			var reqStr = {
				id: id,
				isBorrow: true,
				vUid: YBApp.data.vUid,
			};
			search.deleteBorrow(self, reqStr);
		} else {
			var bReq = {
				id: id
			};
			search.showBorrowOp(self, bReq);
		}
	});
})()