var Uploader = (function(document, undefined) {
	var files = [];
	var index = 0;
	var inputOj = null;
	var maxFile = 6;
	var fileCount = 0;
	var $ = {};
	$.init = function(uploaderInput) {
		inputOj = document.getElementById(uploaderInput);
		this.bind();
		return $;
	};
	$.bind = function() {
		if(isNotBlank(inputOj)) {
			inputOj.onchange = function() {
				var length = this.files.length;
				if((fileCount + length) > maxFile) {
					YBApp.alert.show("最多可以上传6张图片");
					return;
				}
				var file = null;
				for(var i = 0; i < this.files.length; i++) {
					file = this.files[i];
					var fileName = file.name;
					var imgSize = file.size;
					if(imgSize > 3 * 1024 * 1024) { //大于3M
						alert("请上传小于3M的文件");
						return;
					};
					lrz(file, {
						width: 300
					}).then(function(rst) {
						var imgObj = {
							imgBase64: rst.base64,
							imgSize: rst.base64.length,
							imgName: fileName
						}
						$.addFile(imgObj);
					});
				}
			};
		}
	};
	$.addFile = function(imgObj) {
		if(fileCount >= maxFile) {
			YBApp.alert.show("最多可以上传6张图片");
			return;
		}
		fileCount++;
		index++;
		var imgId = "img-" + index;
		files.push({
			imgId: imgId,
			imgName: imgObj.imgName,
			imgBase64: imgObj.imgBase64,
			size: imgObj.imgSize
		});
		var li = document.createElement('li');
		li.setAttribute('imgId', imgId);
		li.setAttribute('id', imgId);
		li.className = 'weui-uploader__file';
		li.style.backgroundImage = "url(" + imgObj.imgBase64 + ")";

		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'img-delete');
//		closeButton.innerHTML = 'X';
		closeButton.addEventListener('tap', function(event) {
			setTimeout(function() {
				$.deleteFile(imgId);
			}, 0);
		}, false);
		li.appendChild(closeButton);
		document.getElementById('uploaderFiles').appendChild(li);
	};
	$.deleteFile = function(imgId) {
		document.getElementById(imgId).remove();
		for(var i = 0; i < files.length; i++) {
			var obj = files[i];
			if(obj.imgId == imgId) {
				files.splice(i, 1);
			};
		}
		fileCount--;
	};
	$.getFile = function() {
		return files;
	}
	return $;
})(document);