(function() {
	var orderNo;
	var vipType = getQueryString("vipType");

	ybAjaxGet("/services/order/createVipPayOrder", {
		vipType: vipType
	}, function(jsonObj) {
		if(jsonObj.success) {
			var r = jsonObj.data;
			orderNo = r.id;
			setEleText('accountPayable', r.residualAmountPayS);
			initShow();
		} else {
			if(jsonObj.code == 301) {
				YBApp.openWindow('/login.html');
			} else {
				if(isNotBlank(jsonObj.msg)) {
					showEle('payment-error');
					hideEle('payment-content');
				}
			}
		}
	}, true);

	//	getEle('allOrderBtn').addEventListener('tap', function() {
	//		YBApp.confirm.show('您确定要离开支付吗？', function(e) {
	//			if(e.index == 0) {
	//				YBApp.openWindow("/index.html");
	//			}
	//		}, ['确定离开', '继续支付']);
	//	});

	mui('#payment-content').on('change', 'input', function() {
		var id = this.id;
		var checked = this.checked;
		if(!checked) {
			this.checked = true;
		} else {
			getEle('weixinPayCB').checked = false;
			getEle('aliPayCB').checked = false;
			getEle('unionPayCB').checked = false;
			this.checked = checked;
		}
		initShow();
	});

	getEle('pay-confirm-btn').addEventListener('tap', function() {
		thirdPartyPay();
	});

	function initShow() {
		if(!getEle('weixinPayCB').checked && !getEle('aliPayCB').checked && !getEle('unionPayCB').checked) {
			var wxd = jQuery('#weixinPay').css('display');
			var alid = jQuery('#aliPay').css('display');
			var uniond = jQuery('#unionPay').css('display');
			if(!isContains(wxd, 'none')) {
				getEle('weixinPayCB').checked = true;
			} else if(!isContains(alid, 'none')) {
				getEle('aliPayCB').checked = true;
			} else if(!isContains(uniond, 'none')) {
				getEle('unionPayCB').checked = true;
			}
		}
	}
	var pays = {};
	if(mui.os.plus) {
		document.addEventListener('plusready', plusReady, false);

		function plusReady() {
			// 获取支付通道
			plus.payment.getChannels(function(channels) {
				for(var i in channels) {
					var channel = channels[i];
					pays[channel.id] = channel;
					checkServices(channel);
				}
			}, function(e) {});
		}
	}

	function thirdPartyPay() {
		if(getEle('weixinPayCB').checked) {
			if(mui.os.plus) { //app
				plusPayChannel('wxpay');
			} else if(mui.os.wechat) { //微信客户端
				ybAjaxGet(YBApp.URL.WX_GET_OPENID, {
					orderNo: orderNo
				}, function(jsonObj) {
					if(jsonObj.success) {
						YBApp.openWindow('/order/wxPayWait.html?orderNo=' + orderNo + '&openid=' + jsonObj.data.openid);
					} else {
						if(jsonObj.code == 301) {
							YBApp.openWindow('/login.html');
						} else if(jsonObj.code == 501) {
							YBApp.openWindow(jsonObj.data.url);
						} else {
							if(isNotBlank(jsonObj.msg)) {
								YBApp.toast(false, jsonObj.msg);
							}
						}
					}
				}, true);
			} else { //手机浏览器

			}
		} else if(getEle('aliPayCB').checked) {
			if(mui.os.plus) { //app
				plusPayChannel('alipay');
			} else if(mui.os.wechat) { //微信客户端

			} else { //手机浏览器
				ybAjaxGet("/services/alipay/getPayRequestContentForH5", {
					orderNo: orderNo
				}, function(jsonObj) {
					if(jsonObj.success) {
						var div = document.createElement("div");
						div.innerHTML = jsonObj.data.req;
						document.body.appendChild(div);
						//appendChild进去的submit()没有起到效果，所以下面再执行一下
						document.forms[0].submit();
					} else {
						if(jsonObj.code == 301) {
							YBApp.openWindow('/login.html');
						} else {
							if(isNotBlank(jsonObj.msg)) {
								YBApp.toast(false, jsonObj.msg);
							}
						}
					}
				}, true);
			}
		} else if(getEle('unionPayCB').checked) {

		}
	}

	function plusPayChannel(channelId) {
		var payChannel = pays[channelId];
		checkServices(payChannel);
		var URL = "";
		if(channelId.indexOf('alipay') >= 0) {
			URL = YBApp.URL.ALIPAY_GET_PAYREQCONFORAPP;
		} else if(channelId.indexOf('wxpay') >= 0) {
			URL = YBApp.URL.WX_GET_BRANDPAYJSON;
		}
		ybAjaxGet(URL, {
			orderNo: orderNo
		}, function(jsonObj) {
			if(jsonObj.success) {
				var r = jsonObj.data;
				var data = r.req;
				//YBApp.alert.show(data);
				plus.payment.request(payChannel, data, function(result) {
					YBApp.openWindow(r.url);
				}, function(e) {
					YBApp.alert.show("支付失败，请稍后重试或选择其他支付方式");
					//YBApp.alert.show("[" + e.code + "]：" + e.message);
				});
			} else {
				if(jsonObj.code == 301) {
					YBApp.openWindow('/login.html');
				} else {
					if(isNotBlank(jsonObj.msg)) {
						YBApp.toast(false, jsonObj.msg);
					}
				}
			}
		}, true);
	}

	function checkServices(pc) {
		if(!pc.serviceReady) {
			var txt = null;
			switch(pc.id) {
				case "alipay":
					txt = "系统未安装“支付宝快捷支付服务”，无法完成支付操作，是否立即安装？";
					break;
				default:
					txt = "系统未安装“" + pc.description + "”服务，无法完成支付，是否立即安装？";
					break;
			}
			plus.nativeUI.confirm(txt, function(e) {
				if(e.index == 0) {
					pc.installService();
				}
			}, pc.description);
		}
	}
}())