/**
 * 弹出选择列表插件
 * 此组件依赖 listpcker ，请在页面中先引入 mui.picker.css + mui.picker.js
 */

(function($, document) {

	//创建 DOM
	$.dom = function(str) {
		if(typeof(str) !== 'string') {
			if((str instanceof Array) || (str[0] && str.length)) {
				return [].slice.call(str);
			} else {
				return [str];
			}
		}
		if(!$.__create_dom_div__) {
			$.__create_dom_div__ = document.createElement('div');
		}
		$.__create_dom_div__.innerHTML = str;
		return [].slice.call($.__create_dom_div__.childNodes);
	};

	var panelBuffer = '<div class="mui-poppicker">\
		<div class="mui-poppicker-header">\
			<button class="mui-btn mui-poppicker-btn-ok mui-hidden">确定</button>\
			<button class="mui-btn mui-poppicker-btn-cancel">取消</button>\
			<div class="mui-poppicker-clear"></div>\
		</div>\
		<div class="mui-poppicker-body">\
		</div>\
		<div>\
  			<div class="goods-info-button button-borrow">\
			借&nbsp;&nbsp;阅\
			</div>\
		</div>\
	</div>';

	var pickerBuffer = '<div class="goods-info">\
			<div>\
				<img class="goods-info-icon" src="">\
				<div class="goods-info-body">\
					<span class="goods-info-name"></span>\
						<div class="goods-info-price">\
							<span class="yb-title-text-pormpt">借阅价:<span class="price" style="margin-top: 5px;">¥<b class="pop-picker-price">0.00</b></span>/天</span>\
						</div>\
						<div class="goods-info-vip-price mui-hidden">\
							<span class="yb-title-text-pormpt">VIP借阅价:<span class="price" style="margin-top: 5px;">¥<b class="pop-picker-vip-price"></b></span>/天</span>\
							<span class="yb-title-text-pormpt-small" style="margin-left: 10px;"><del>¥<span class="pop-picker-vip-delprice">0.00</span></del>\
							<span class="yb-title-text-pormpt pop-picker-vip-discount" style="margin-left: 10px;"></span>\
						</div>\
				</div>\
			</div>\
			<div>\
			<span class="goods-options-descr yb-title-text-pormpt-small"></span>\
			</div>\
			<div class="goods-options">\
			</div>\
	</div>';

	//定义弹出选择器类
	var PopPicker = $.PopPicker = $.Class.extend({
		//构造函数
		init: function(options) {
			var self = this;
			self.options = options || {};
			self.options.buttons = self.options.buttons || ['取消', '确定'];
			self.panel = $.dom(panelBuffer)[0];
			document.body.appendChild(self.panel);
			self.ok = self.panel.querySelector('.mui-poppicker-btn-ok');
			self.cancel = self.panel.querySelector('.mui-poppicker-btn-cancel');
			self.buy = self.panel.querySelector('.button-buy');
			self.borrow = self.panel.querySelector('.button-borrow');
			self.body = self.panel.querySelector('.mui-poppicker-body');
			self.mask = $.createMask();
			self.cancel.innerText = self.options.buttons[0];
			self.ok.innerText = self.options.buttons[1];
			self.cancel.addEventListener('tap', function(event) {
				self.hide();
			}, false);
			self.ok.addEventListener('tap', function(event) {
				if(self.callback) {
					var rs = self.callback(self.getSelectedItems());
					if(rs !== false) {
						self.hide();
					}
				}
			}, false);
			self.borrow.addEventListener('tap', function(event) {
				if(self.callback) {
					var rs = self.callback(self.getSelectedItems());
					if(rs !== false) {
						self.hide();
					}
				}
			}, false);
			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
			self._createPicker();
			//防止滚动穿透
			self.panel.addEventListener('touchstart', function(event) {
				event.preventDefault();
			}, false);
			self.panel.addEventListener('touchmove', function(event) {
				event.preventDefault();
			}, false);
		},
		_createPicker: function() {
			var self = this;
			var layer = self.options.layer || 1;
			var pickerElement = $.dom(pickerBuffer)[0];
			pickerElement.style.width = '100%';
			self.body.appendChild(pickerElement);

		},
		//填充数据
		setData: function(data) {
			var self = this;

			self.name = self.panel.querySelector('.goods-info-name');
			self.priceDiv = self.panel.querySelector('.goods-info-price');
			self.vipPriceDiv = self.panel.querySelector('.goods-info-vip-price');
			self.options = self.panel.querySelector('.goods-options');
			self.optionsDescr = self.panel.querySelector('.goods-options-descr');

			self.price = self.panel.querySelector('.pop-picker-price');
			self.vipPrice = self.panel.querySelector('.pop-picker-vip-price');
			self.vipDiscount = self.panel.querySelector('.pop-picker-vip-discount');
			self.delPrice = self.panel.querySelector('.pop-picker-vip-delprice');
			self.icon = self.panel.querySelector('.goods-info-icon');
			self.icon.src = "/images/product/s300x300/"+data.icon;
			self.name.innerText = data.name;
			if(data.vipDiscount > 0 && data.vipDiscount < 1) {
				self.vipPriceDiv.classList.remove("mui-hidden");
				self.priceDiv.classList.add("mui-hidden");
				self.vipDiscount.innerText = data.vipDiscountS;
				self.delPrice.innerText = data.rentalS;
			}
			var innerHtml = "";
			var odata = data.lendBookOptions;
			var ops = odata.op1.op;
			self.optionsDescr.innerText = odata.op1.name;
			mui.each(ops, function(idx, obj) {
				var ev;
				var classl = '';
				var rentalS = '';
				var dRentalS = '';
				try {
					ev = eval('odata.stock.p_' + obj.id + '_0');
					if(isNotBlank(ev) && ev.enable) {
						if(ev.selected) {
							classl = 'mui-btn mui-btn-selected';
							self.price.innerText = ev.rentalS;
							self.delPrice.innerText = ev.rentalS;
							self.vipPrice.innerText = ev.DRentalS;
							self.selectId = obj.id;
						} else {
							classl = 'mui-btn mui-btn-enable-select';
						}
						rentalS = ev.rentalS;
						dRentalS = ev.DRentalS;
					} else {
						classl = 'mui-btn mui-btn-unable-select';
					}
					innerHtml += '<button type="button" data-id="' + obj.id + '" data-rental="' + rentalS + '" data-dRental="' + dRentalS + '" class="' + classl + '">' + obj.name + '</button>';
				} catch(e) {}
			});
			self.options.innerHTML = innerHtml;
			mui('.goods-options').on('tap', 'button', function() {
				if(this.classList.contains('mui-btn-unable-select') || this.classList.contains('mui-btn-selected')) {
					return;
				}
				var opId = this.getAttribute('data-id');
				self.selectId = opId;
				var selected = this.parentNode.querySelector(".mui-btn-selected");
				if(isNotBlank(selected)) {
					var classList = selected.classList;
					classList.remove('mui-btn-selected');
					classList.add('mui-btn-enable-select');
				}
				this.classList.remove('mui-btn-enable-select');
				this.classList.add('mui-btn-selected');

				var opRental = this.getAttribute('data-rental');
				var opDRental = this.getAttribute('data-dRental');
				self.price.innerText = opRental;
				self.delPrice.innerText = opRental;
				self.vipPrice.innerText = opDRental;
			});
		},
		//获取选中的项（数组）
		getSelectedItems: function() {
			var self = this;
			return self.selectId ;
		},
		//显示
		show: function(callback) {
			var self = this;
			self.callback = callback;
			self.mask.show();
			document.body.classList.add($.className('poppicker-active-for-page'));
			self.panel.classList.add($.className('active'));
			//处理物理返回键
			self.__back = $.back;
			$.back = function() {
				self.hide();
			};
		},
		//隐藏
		hide: function() {
			var self = this;
			if(self.disposed) return;
			self.panel.classList.remove($.className('active'));
			self.mask.close();
			document.body.classList.remove($.className('poppicker-active-for-page'));
			//处理物理返回键
			$.back = self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for(var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});

})(mui, document);