/**
 * 弹出选择列表插件
 * 此组件依赖 listpcker ，请在页面中先引入 mui.picker.css + mui.picker.js
 */

(function($, document) {

	//创建 DOM
	$.dom = function(str) {
		if(typeof(str) !== 'string') {
			if((str instanceof Array) || (str[0] && str.length)) {
				return [].slice.call(str);
			} else {
				return [str];
			}
		}
		if(!$.__create_dom_div__) {
			$.__create_dom_div__ = document.createElement('div');
		}
		$.__create_dom_div__.innerHTML = str;
		return [].slice.call($.__create_dom_div__.childNodes);
	};

	var panelBuffer = '<div class="mui-poppicker">\
		<div class="mui-poppicker-body">\
		</div>\
		<div>\
  			<div class="goods-info-button button-cannel">\
			取&nbsp;&nbsp;消\
			</div>\
		</div>\
	</div>';

	var pickerBuffer = '<div id="nativeShare">\
			<div class="label">分享到</div>\
            <div class="list clearfix">\
            <span data-app="weixin" class="nativeShare weixin"><i></i>微信好友</span>\
            <span data-app="weixinFriend" class="nativeShare weixin_timeline"><i></i>微信朋友圈</span>\
            <span data-app="sinaWeibo" class="nativeShare weibo"><i></i>新浪微博</span>\
            </div>\
            </div>';

	var qApiSrc = {
		lower: "http://3gimg.qq.com/html5/js/qb.js",
		higher: "http://jsapi.qq.com/get?api=app.share"
	};
	var bLevel = {
		qq: {
			forbid: 0,
			lower: 1,
			higher: 2
		},
		uc: {
			forbid: 0,
			allow: 1
		}
	};
	var UA = navigator.appVersion;
	var isqqBrowser = (UA.split("MQQBrowser/").length > 1) ? bLevel.qq.higher : bLevel.qq.forbid;
	var isucBrowser = (UA.split("UCBrowser/").length > 1) ? bLevel.uc.allow : bLevel.uc.forbid;
	var version = {
		uc: "",
		qq: ""
	};
	var isWeixin = false;
	//定义弹出选择器类
	var PopPicker = $.PopPicker = $.Class.extend({
		//构造函数
		init: function(config) {
			var self = this;
			self.config = config;
			self.panel = $.dom(panelBuffer)[0];
			document.body.appendChild(self.panel);
			self.cannel = self.panel.querySelector('.button-cannel');
			self.body = self.panel.querySelector('.mui-poppicker-body');
			self.mask = $.createMask();
			self._createPicker();

			self.cannel.addEventListener('tap', function(event) {
				self.hide();
			}, false);
			self.mask[0].addEventListener('tap', function() {
				self.hide();
			}, false);
			//防止滚动穿透
			self.panel.addEventListener('touchstart', function(event) {
				event.preventDefault();
			}, false);
			self.panel.addEventListener('touchmove', function(event) {
				event.preventDefault();
			}, false);

			mui('.clearfix').on('tap', 'span', function() {
				var opId = this.getAttribute('data-app');
				self.share(opId);
				self.hide();
			});

			config = config || {};
			self.url = config.url || document.location.href || '';
			self.title = config.title || document.title || '';
			self.desc = config.desc || document.title || '';
			self.img = config.img || document.getElementsByTagName('img').length > 0 && document.getElementsByTagName('img')[0].src || '';
			self.img_title = config.img_title || document.title || '';
			self.from = config.from || window.location.host || '';

			if(mui.os.plus) {
				self.shares = null;
				document.addEventListener('plusready', plusReady, false);

				function plusReady() {
					plus.share.getServices(function(s) {
						self.shares = {};
						for(var i in s) {
							var t = s[i];
							self.shares[t.id] = t;
						}
					}, function(e) {
						mui.toast("获取分享服务列表失败：" + e.message);
					});
				}
			} else if(mui.os.wechat) {
				
				var div = document.createElement('div');
				var innerHtml = [];
				innerHtml.push('<div id="wechat_share_notice_bg" class="mui-hidden" style="position: fixed; left: 0px; top: 0px; width: 100%; height: 100%; z-index: 1009; animation: opacityIn 1s ease 0.2s both; background: rgba(0, 0, 0, 0.6);"><p class="share_icon" style="clear:both; padding:10px; text-align:right;height:100%;background-position: right top; -webkit-animation:rotateUp 1s .8s ease both;z-index:9999;">');
				if(mui.os.android) {
					innerHtml.push('<img class="mui-android" src="/icon/popup_android.png" alt="" width="100%">');
				} else if(mui.os.ios) {
					innerHtml.push('<img class="mui-android" src="/icon/popup_ios.png" alt="" width="100%">');
				}
				innerHtml.push('</p></div>');
				div.innerHTML = innerHtml.join('');
				document.body.appendChild(div);
				getEle('wechat_share_notice_bg').addEventListener('tap', function() {
					self.hide();
				}, false);
			}

			self.ucAppList = {
				sinaWeibo: ['kSinaWeibo', 'SinaWeibo', 11, '新浪微博'],
				weixin: ['kWeixin', 'WechatFriends', 1, '微信好友'],
				weixinFriend: ['kWeixinFriend', 'WechatTimeline', '8', '微信朋友圈'],
				QQ: ['kQQ', 'QQ', '4', 'QQ好友'],
				QZone: ['kQZone', 'QZone', '3', 'QQ空间']
			};
			platform_os = self.getPlantform();
			version.qq = isqqBrowser ? self.getVersion(UA.split("MQQBrowser/")[1]) : 0;
			version.uc = isucBrowser ? self.getVersion(UA.split("UCBrowser/")[1]) : 0;
			isWeixin = self.is_weixin();
			if((isqqBrowser && version.qq < 5.4 && platform_os == "iPhone") || (isqqBrowser && version.qq < 5.3 && platform_os == "Android")) {
				isqqBrowser = bLevel.qq.forbid
			} else {
				if(isqqBrowser && version.qq < 5.4 && platform_os == "Android") {
					isqqBrowser = bLevel.qq.lower
				} else {
					if(isucBrowser && ((version.uc < 10.2 && platform_os == "iPhone") || (version.uc < 9.7 && platform_os == "Android"))) {
						isucBrowser = bLevel.uc.forbid
					}
				}
			}
			this.isloadqqApi();
		},
		isloadqqApi: function() {
			if(isqqBrowser) {
				var b = (version.qq < 5.4) ? qApiSrc.lower : qApiSrc.higher;
				var d = document.createElement("script");
				var a = document.getElementsByTagName("body")[0];
				d.setAttribute("src", b);
				a.appendChild(d)
			}
		},

		getPlantform: function() {
			ua = navigator.userAgent;
			if((ua.indexOf("iPhone") > -1 || ua.indexOf("iPod") > -1)) {
				return "iPhone"
			}
			return "Android"
		},

		is_weixin: function() {
			var a = UA.toLowerCase();
			if(a.match(/MicroMessenger/i) == "micromessenger") {
				return true
			} else {
				return false
			}
		},

		getVersion: function(c) {
			var a = c.split("."),
				b = parseFloat(a[0] + "." + a[1]);
			return b
		},
		_createPicker: function() {
			var self = this;
			var pickerElement = $.dom(pickerBuffer)[0];
			pickerElement.style.width = '100%';
			self.body.appendChild(pickerElement);
		},
		share: function(to_app) {
			var self = this;
			if(mui.os.plus) {
				var ss = null;
				var x = "";
				if(isContains(to_app, 'weixinFriend')) {
					ss = self.shares['weixin'];
					x = "WXSceneTimeline";
				} else if(isContains(to_app, 'weixin')) {
					ss = self.shares['weixin'];
					x = "WXSceneSession";
				} else if(isContains(to_app, 'sinaWeibo')) {
					ss = self.shares['sinaweibo'];
				}
				if(!ss) {
					return;
				}
				var msg = {
					content: self.desc,
					title: self.title,
					href: self.url,
					thumbs: self.img,
					pictures: self.img,
					extra: {
						scene: x
					}
				};
				// 发送分享
				if(ss.authenticated) {
					self.plushShareMessage(msg, ss);
				} else {
					ss.authorize(function() {
						self.plushShareMessage(msg, ss);
					}, function(e) {
						outLine("认证授权失败：" + e.code + " - " + e.message);
					});
				}
			} else if(mui.os.wechat) {

			} else {
				var title = this.title,
					url = this.url,
					desc = this.desc,
					img = this.img,
					img_title = this.img_title,
					from = this.from;
				if(isucBrowser) {
					to_app = to_app == '' ? '' : (platform_os == 'iPhone' ? this.ucAppList[to_app][0] : this.ucAppList[to_app][1]);
					if(to_app == 'QZone') {
						B = "mqqapi://share/to_qzone?src_type=web&version=1&file_type=news&req_type=1&image_url=" + img + "&title=" + title + "&description=" + desc + "&url=" + url + "&app_name=" + from;
						k = document.createElement("div"), k.style.visibility = "hidden", k.innerHTML = '<iframe src="' + B + '" scrolling="no" width="1" height="1"></iframe>', document.body.appendChild(k), setTimeout(function() {
							k && k.parentNode && k.parentNode.removeChild(k)
						}, 5E3);
					}
					if(typeof(ucweb) != "undefined") {
						ucweb.startRequest("shell.page_share", [title, title, url, to_app, "", "@" + from, ""])
					} else {
						if(typeof(ucbrowser) != "undefined") {
							ucbrowser.web_share(title, title, url, to_app, "", "@" + from, '')
						} else {}
					}
				} else {
					if(isqqBrowser && !isWeixin) {
						to_app = to_app == '' ? '' : this.ucAppList[to_app][2];
						var ah = {
							url: url,
							title: title,
							description: desc,
							img_url: img,
							img_title: img_title,
							to_app: to_app, //微信好友1,腾讯微博2,QQ空间3,QQ好友4,生成二维码7,微信朋友圈8,啾啾分享9,复制网址10,分享到微博11,创意分享13
							cus_txt: "请输入此时此刻想要分享的内容"
						};
						ah = to_app == '' ? '' : ah;
						if(typeof(browser) != "undefined") {
							if(typeof(browser.app) != "undefined" && isqqBrowser == bLevel.qq.higher) {
								browser.app.share(ah)
							}
						} else {
							if(typeof(window.qb) != "undefined" && isqqBrowser == bLevel.qq.lower) {
								window.qb.share(ah)
							} else {}
						}
					} else {}
				}
			}
		},
		plushShareMessage: function(msg, s) {
			s.send(msg, function() {
				mui.toast("分享成功");
			}, function(e) {
				mui.toast("分享失败");
			});
		},
		//显示
		show: function() {
			if(mui.os.wechat) {
				showEle('wechat_share_notice_bg');
			} else {
				var self = this;
				self.mask.show();
				document.body.classList.add($.className('poppicker-active-for-page'));
				self.panel.classList.add($.className('active'));
			}
			//处理物理返回键
			self.__back = $.back;
			$.back = function() {
				self.hide();
			};
		},
		//隐藏
		hide: function() {
			if(mui.os.wechat) {
				hideEle('wechat_share_notice_bg');
			} else {
				var self = this;
				if(self.disposed) return;
				self.panel.classList.remove($.className('active'));
				self.mask.close();
				document.body.classList.remove($.className('poppicker-active-for-page'));
			}
			//处理物理返回键
			$.back = self.__back;
		},
		dispose: function() {
			var self = this;
			self.hide();
			setTimeout(function() {
				self.panel.parentNode.removeChild(self.panel);
				for(var name in self) {
					self[name] = null;
					delete self[name];
				};
				self.disposed = true;
			}, 300);
		}
	});

})(mui, document);